//
// Created by QP on 2025/4/12.
//

#ifndef PCL_WRAPPER_IO_HPP
#define PCL_WRAPPER_IO_HPP
#pragma once
#include <string>
#include "cloud_handle.hpp"
#include <pcl/io/pcd_io.h>

namespace pcl_wrapper {

    bool loadPCD_XYZ(const std::string& filename, PointCloudXYZ& out) {
        return pcl::io::loadPCDFile<pcl::PointXYZ>(filename, *out.cloud) == 0;
    }

    bool loadPCD_XYZI(const std::string& filename, PointCloudXYZI& out) {
        return pcl::io::loadPCDFile<pcl::PointXYZI>(filename, *out.cloud) == 0;
    }

    bool savePCD_XYZ(const std::string& filename, const PointCloudXYZ& cloud) {
        return pcl::io::savePCDFileBinary(filename, *cloud.cloud) == 0;
    }

    bool savePCD_XYZI(const std::string& filename, const PointCloudXYZI& cloud) {
        return pcl::io::savePCDFileBinary(filename, *cloud.cloud) == 0;
    }
}
#endif //PCL_WRAPPER_IO_HPP
