//
// Created by QP on 2025/4/12.
//

#ifndef PCL_WRAPPER_PCL_WRAPPER_API_HPP
#define PCL_WRAPPER_PCL_WRAPPER_API_HPP
#pragma once
#ifdef __cplusplus
extern "C" {
#endif

// ========== Cloud ==========

void* create_pointcloud_xyz();
void* create_pointcloud_xyzi();
void  reserve_pointcloud_xyz(void* cloud, int count);
void  set_point_xyz(void* cloud, int index, float x, float y, float z);
void  set_point_xyzi(void* cloud, int index, float x, float y, float z, float intensity);
void  delete_pointcloud(void* cloud);

// ========== Voxel Filter ==========

void* create_voxel_filter_xyz();
void* create_voxel_filter_xyzi();
void  set_voxel_leaf_size(void* filter, float lx, float ly, float lz);
void  set_voxel_input_cloud(void* filter, void* cloud);
void* apply_voxel_filter_xyz(void* filter);
void* apply_voxel_filter_xyzi(void* filter);
void  delete_voxel_filter(void* filter);

// ========= IO ==========
bool load_pcd_xyz(const char* filename, void* out);
bool load_pcd_xyzi(const char* filename, void* out);
bool save_pcd_xyz(const char* filename, void* cloud);
bool save_pcd_xyzi(const char* filename, void* cloud);

#ifdef __cplusplus
}
#endif

#endif //PCL_WRAPPER_PCL_WRAPPER_API_HPP
