//
// Created by QP on 2025/4/12.
//

#ifndef PCL_WRAPPER_VOXEL_FILTER_HPP
#define PCL_WRAPPER_VOXEL_FILTER_HPP
#pragma once
#include <pcl/filters/voxel_grid.h>

namespace pcl_wrapper {

    template<typename PointT>
    struct VoxelGridWrapper {
        pcl::VoxelGrid<PointT> filter;

        void setInputCloud(typename pcl::PointCloud<PointT>::Ptr cloud) {
            filter.setInputCloud(cloud);
        }

        void setLeafSize(float lx, float ly, float lz) {
            filter.setLeafSize(lx, ly, lz);
        }

        typename pcl::PointCloud<PointT>::Ptr filterCloud() {
            typename pcl::PointCloud<PointT>::Ptr result(new pcl::PointCloud<PointT>());
            filter.filter(*result);
            return result;
        }
    };

    using VoxelGridXYZ  = VoxelGridWrapper<pcl::PointXYZ>;
    using VoxelGridXYZI = VoxelGridWrapper<pcl::PointXYZI>;

} // namespace pcl_wrapper

#endif //PCL_WRAPPER_VOXEL_FILTER_HPP
